if (!window.xe) xe = {};

xe.Editors = [];

function editorStart_xe(editor_sequence, primary_key, content_key, editor_height, colorset, content_style, content_font, content_font_size) {
	if(typeof(colorset)=='undefined') colorset = 'white';
	if(typeof(content_style)=='undefined') content_style = 'xeStyle';
	if(typeof(content_font)=='undefined') content_font= '';
	if(typeof(content_font_size)=='undefined') content_font_size= '';

	var target_src = request_uri+'modules/editor/styles/'+content_style+'/editor.html';

	var textarea = jQuery("#xpress-editor-"+editor_sequence);
	var iframe   = jQuery('<iframe id="editor_iframe_'+editor_sequence+'" allowTransparency="true" frameborder="0" src="'+target_src+'" scrolling="yes" style="width:100%;height:'+editor_height+'px">');
	var htmlsrc  = jQuery('<textarea rows="10" cols="20" class="input_syntax '+colorset+'"></textarea>');
	var form	 = textarea.get(0).form;
	form.setAttribute('editor_sequence', editor_sequence);

	var saved_content = '';
	if(jQuery("input[name=content]",form).size()>0){
		saved_content=jQuery("input[name=content]",form).val().replace(/src=\"files\/attach/g,'src="'+request_uri+'files/attach'); //'
		jQuery("#xpress-editor-"+editor_sequence).val(saved_content);
	}

	// create an editor
	var oEditor		  = new xe.XpressCore();
	var oWYSIWYGIFrame   = iframe.get(0);
	var oIRTextarea	  = textarea.get(0);
	var oHTMLSrcTextarea = htmlsrc.get(0);
	var elAppContainer   = jQuery('.xpress-editor', form).get(0);

	oEditor.getFrame = function(){ return oWYSIWYGIFrame;}
	oEditor.getContent = function(){
		editorGetContentTextarea_xe(editor_sequence);
	}
	
	var content = form[content_key].value;
	if(xFF && !content) content = '<br />';

	// src, href, url의 XE 상대경로를 http로 시작하는 full path로 변경
	content = editorReplacePath(content);

	form[content_key].value = content;
	jQuery("#xpress-editor-"+editor_sequence).val(content);

	// Set standard API
	editorRelKeys[editor_sequence] = new Array();
	editorRelKeys[editor_sequence]["primary"]   = form[primary_key];
	editorRelKeys[editor_sequence]["content"]   = form[content_key];
	editorRelKeys[editor_sequence]["func"]	  = editorGetContentTextarea_xe;
	editorRelKeys[editor_sequence]["editor"]	= oEditor;
	editorRelKeys[editor_sequence]["pasteHTML"] = function(text){
		oEditor.exec('PASTE_HTML',[text]);
	}
	xe.Editors[editor_sequence] = oEditor;
		
	function callTinyMCE(){
    	tinyMCE.init({
        // General options
        mode : "textareas",
        theme : "advanced",
        plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount",

        // Theme options
        theme_advanced_buttons1 : "undo,redo,|,styleselect,formatselect,fontsizeselect,fontselect,|,bold,italic,underline,strikethrough,sub,sup,|,forecolor,backcolor,|",
        theme_advanced_buttons2 : "code,preview,fullscreen,|,cleanup,styleprops,del,ins,|justifyleft,justifycenter,justifyright,justifull,bullist,numlist,outdent,indent,blockquote,|,link,unlink,anchor,search,replace,|,visualchars,nonbreaking,template,pagebreak,|",
        theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,vasualid,|,charmap,emotion,iespell,media,advhr,image,|,insertlayer,moveforward,movebackward,absolute,|,attribs",
        theme_advanced_toolbar_location : "top",
        theme_advanced_toolbar_align : "left",
        theme_advanced_statusbar_location : "bottom",
        theme_advanced_resizing : true,

        // Example content CSS (should be your site CSS)
        content_css : "css/content.css",

        // Drop lists for link/image/media/template dialogs
        template_external_list_url : "list/template_list.js",
        external_link_list_url : "lists/link_list.js",
        external_image_list_url : "lists/image_list.js",
        media_external_list_url : "lists/media_list.js",
        
        force_br_newlines : true,
       
        // Replace values for the template plugin
        template_replace_values : {
                username : "Some User",
                staffid : "991234"
        }
    	});
	}
	
	callTinyMCE();
	
	return oEditor;
}

function editorGetContentTextarea_xe(editor_sequence) {
	var str = tinyMCE.get('xpress-editor-'+editor_sequence).getContent();
	if(!jQuery.trim(str.replace(/(&nbsp;|<\/?(p|br|span|div)([^>]+)?>)/ig, ''))) return '';

	// 파이어폭스의 경우 의미없는 <br>이 컨텐트 마지막에 추가될 수 있다.
	str = str.replace(/<br ?\/?>$/i, '');

	// 속도 문제가 있으므로 1024 문자 미만일 때만 첫 노드가 텍스트 노드인지 테스트
	// 그 이상이면 P 노드가 정상적으로 생성되었다고 가정한다.
	if (str.length < 1024) {
		var inline_elements = Array('#text','A','BR','IMG','EM','STRONG','SPAN','BIG','CITE','CODE','DD','DFN','HR','INS','KBD','LINK','Q','SAMP','SMALL','SUB','SUP','TT');
		var is_inline_contents = true;
		var div   = jQuery('<div>'+str+'</div>').eq(0);
		var nodes = div.contents();
		jQuery.each(nodes, function() {
			if (this.nodeType != 3) {
				if(jQuery.inArray(this.nodeName, inline_elements ) == -1) {
					is_inline_contents = false;
				}
			}
		});
		if(is_inline_contents) str = '<p>'+str+'</p>';
	}

	// 이미지 경로를 수정한다. - 20091125
	str = str.replace(/src\s?=\s?(["']?)(?:\.\.\/)+(files\/attach\/)/ig, function(m0,m1,m2){
		return 'src='+(m1||'')+m2;
	});

	str = str.replace(/\<(\/)?([A-Z]+)([^>]*)\>/ig, function(m0,m1,m2,m3) {
		if(m3) {
			m3 = m3.replace(/ ([A-Z]+?)\=/ig, function(n0,n1) {
				n1 = n1.toLowerCase();
				return ' '+n1+'=';
			});
		} else { m3 = ''; }
		m2 = m2.toLowerCase();
		if(!m1) m1='';
		return '<'+m1+m2+m3+'>';
	});
	str = str.replace('<br>','<br />');
	
	return str;
}

function editorGetIframe(srl) {
	return tinyMCE.get('xpress-editor-'+editor_sequence);
}

function editorFocus(editor_sequence) {
	try {
		editor.execInstanceCommand("mceFocus", true, "xpress-editor-"+editor_sequence);
	} catch(e){}
}

function editorReplaceHTML(iframe_obj, content) {
	// src, href, url의 XE 상대경로를 http로 시작하는 full path로 변경
	content = editorReplacePath(content);
	tinyMCE.execCommand("mceReplaceContent", false,  content);
	//var srl = parseInt(iframe_obj.id.replace(/^.*_/,''),10);
	//editorRelKeys[srl]["pasteHTML"](content);
}

function editorReplacePath(content) {
	// 태그 내 src, href, url의 XE 상대경로를 http로 시작하는 full path로 변경
	content = content.replace(/\<([^\>\<]*)(src=|href=|url\()("|\')*([^"\'\)]+)("|\'|\))*(\s|>)*/ig, function(m0,m1,m2,m3,m4,m5,m6) {
		if(m2=="url(") { m3=''; m5=')'; } else { if(typeof(m3)=='undefined') m3 = '"'; if(typeof(m5)=='undefined') m5 = '"'; if(typeof(m6)=='undefined') m6 = ''; }
		var val = jQuery.trim(m4).replace(/^\.\//,'');
		if(/^(http\:|https\:|ftp\:|telnet\:|mms\:|mailto\:|\/|\.\.|\#)/i.test(val)) return m0;
		return '<'+m1+m2+m3+request_uri+val+m5+m6;
	});
	return content;
}

function editorGetAutoSavedDoc(form) {
	var param = new Array();
	param['mid'] = current_mid;
	param['editor_sequence'] = form.getAttribute('editor_sequence')
	setTimeout(function() {
	  var response_tags = new Array("error","message","editor_sequence","title","content","document_srl");
	  exec_xml('editor',"procEditorLoadSavedDocument", param, function(a,b,c) { editorRelKeys[param['editor_sequence']]['primary'].value = a['document_srl']; if(typeof(uploadSettingObj[param['editor_sequence']]) == 'object') editorUploadInit(uploadSettingObj[param['editor_sequence']], true); }, response_tags);
	}, 0);
	
}

// WYSIWYG 모드를 저장하는 확장기능
xe.XE_GET_WYSYWYG_MODE = jQuery.Class({
	name : "XE_GET_WYSYWYG_MODE",

	$init : function(editor_sequence) {
		this.editor_sequence = editor_sequence;
	},

	$ON_CHANGE_EDITING_MODE : function(mode) {
		editorMode[this.editor_sequence] = (mode =='HTMLSrc') ? 'html' : 'wysiwyg';
	}
});

// 이미지등의 상대경로를 절대경로로 바꾸는 플러그인
xe.XE_GET_WYSYWYG_CONTENT = jQuery.Class({
	name : "XE_GET_WYSYWYG_CONTENT",

	$ON_MSG_APP_READY : function() {
		this.oApp.addConverter("IR_TO_WYSIWYG", this.replaceXE2HTTP);
		this.oApp.addConverter("WYSIWYG_TO_IR", this.replaceHTTP2XE);
	},

	replaceXE2HTTP : function(content) {
		// src, href, url의 XE 상대경로를 http로 시작하는 full path로 변경
		content = editorReplacePath(content);

		return content;
	},

	replaceHTTP2XE : function(content) {
		// src, href, url에서 http로 시작하는 full path를 XE 상대경로로 변경
		content = content.replace(/(src=|href=|url\()("|\')*([^"\'\)]+)("|\'|\))*(\s|>|\))*/ig, function(m0,m1,m2,m3,m4,m5) {
			var uriReg = new RegExp('^'+request_uri.replace('\/','\\/'),'ig');
			if(m1=="url(") { m2=''; m4=')'; } else { if(typeof(m2)=='undefined') m2 = '"'; if(typeof(m4)=='undefined') m4 = '"'; if(typeof(m5)=='undefined') m5 = ''; }
			var val = jQuery.trim(m3);
			if(uriReg.test(val)) val = val.replace(uriReg,'');
			else val = m3;
			return m1+m2+val+m4+m5;
		});
		return content;
	}
});

// 서식 기본 내용을 보존
xe.XE_PreservTemplate = jQuery.Class({
	name : "XE_PreservTemplate",
	isRun : false,

	$BEFORE_SET_IR : function(content) {
		if(!this.isRun && !content) {
			this.isRun = true;
			return false;
		}
	}
});

// 미리보기 확장기능
xe.XE_Preview = jQuery.Class({
	name  : "XE_Preview",
	elPreviewButton : null,

	$init : function(elAppContainer) {
		this._assignHTMLObjects(elAppContainer);
	},

	_assignHTMLObjects : function(elAppContainer) {
		this.elPreviewButton = jQuery("BUTTON.xpress_xeditor_preview_button", elAppContainer);
	},

	$ON_MSG_APP_READY : function() {
		this.oApp.registerBrowserEvent(this.elPreviewButton.get(0), "click", "EVENT_PREVIEW", []);
	},

	$ON_EVENT_PREVIEW : function() {
		// TODO : 버튼이 눌렸을 때의 동작 정의
	}
});